/***********************************************************************
 *                Wort Uhr
 *            ================
 *            Uwe Berger; 2010
 * 
 * 
 * Version fuer (nativ) X.
 * 
 * ---------
 * Have fun!
 * 
 **********************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>

// Default-Werte
#define WINDOW_WIDTH	10
#define WINDOW_HEIGHT	WINDOW_WIDTH


int now_s, now_m, now_h;
time_t now;
struct tm *now_tm;

/*
    0 1 2 3 4 5 6 7 8 9 0

0   I T K I S G H A L F E   ==>  it is half
11  T E N Y Q U A R T E R   ==>  ten quarter
22  D T W E N T Y F I V E   ==>  twenty|five
33  T O P A S T E F O U R   ==>  to past four
44  F I V E T W O N I N E   ==>  five two nine
55  T H R E E T W E L V E   ==>  three twelve
66  B E L E V E N O N E S   ==>  eleven one
77  S E V E N W E I G H T   ==>  seven eight
88  I T E N S I X T I E S   ==>  ten six
99  T I N E O I C L O C K   ==>  o_clock
*/

// Buchstabenmatrix
char signs[][2] = {
	{'I',0},{'T',0},{'K',0},{'I',0},{'S',0},{'G',0},{'H',0},{'A',0},{'L',0},{'F',0},{'E',0},
	{'T',0},{'E',0},{'N',0},{'Y',0},{'Q',0},{'U',0},{'A',0},{'R',0},{'T',0},{'E',0},{'R',0},
	{'D',0},{'T',0},{'W',0},{'E',0},{'N',0},{'T',0},{'Y',0},{'F',0},{'I',0},{'V',0},{'E',0},
	{'T',0},{'O',0},{'P',0},{'A',0},{'S',0},{'T',0},{'E',0},{'F',0},{'O',0},{'U',0},{'R',0},
	{'F',0},{'I',0},{'V',0},{'E',0},{'T',0},{'W',0},{'O',0},{'N',0},{'I',0},{'N',0},{'E',0},
	{'T',0},{'H',0},{'R',0},{'E',0},{'E',0},{'T',0},{'W',0},{'E',0},{'L',0},{'F',0},{'E',0},
	{'B',0},{'E',0},{'L',0},{'E',0},{'V',0},{'E',0},{'N',0},{'O',0},{'N',0},{'E',0},{'S',0},
	{'S',0},{'E',0},{'V',0},{'E',0},{'N',0},{'W',0},{'E',0},{'I',0},{'G',0},{'H',0},{'T',0},
	{'I',0},{'T',0},{'E',0},{'N',0},{'S',0},{'I',0},{'X',0},{'T',0},{'I',0},{'E',0},{'S',0},
	{'T',0},{'I',0},{'N',0},{'E',0},{'O',0},{'I',0},{'C',0},{'L',0},{'O',0},{'C',0},{'K',0}	
};

// Worte [0]->Offset; [1]->Laenge
const char it[]		= {0,2};
const char is[]		= {3,2};
const char half[]	= {6,5};
const char ten[]	= {11,3};
const char quarter[]= {15,7};
const char twenty[] = {23,6};
const char five[]	= {29,4};
const char to[]		= {33,2};
const char past[]	= {35,4};
const char o[]		= {103,1};
const char _clock[] = {105,5};

// Stundentexte [0]->Offset; [1]->Laenge
const char htxt[][2] = {
						{73,3}, //1
						{48,3}, //2
						{55,5}, //3
						{40,4}, //4
						{44,4}, //5
						{92,3}, //6
						{77,5}, //7
						{83,5}, //8
						{51,4}, //9
						{89,3}, //10
						{67,6}, //11
						{60,6}  //12
					};

char min[] = {0,0,0,0};
char ap[] = {0,0};

Display *mydpy;
Window mywin;
char win_title[] = {"Word Clock"};

// Font...
char* font_name = "-*-courier-bold-r-*-*-28-*-*-*-*-*-*-*";
XFontStruct* font_info;


//**********************************************************************
static void setcolourvianame (Display *display, int screen, GC myGC, char *colourname) {
	/* genaue RGB  Komponenten der Farbe */
	XColor rgbcolour;
	/* am naheste liegende RGB-Farben der Hardware */
	XColor hwarecolour;
	int status;
	/* Colormap */
	Colormap  myColourmap;
	int myDepth;

	myDepth = DefaultDepth (display, screen);
	myColourmap = DefaultColormap (display, screen);
	screen = DefaultScreen (display);
	if (myDepth > 1) {
		status = XLookupColor (
					display, myColourmap,colourname,&rgbcolour,&hwarecolour );
		if (status != 0) {
			/* Farben für die Color map reservieren */
			status = XAllocColor ( display, myColourmap, &hwarecolour);
			if (status != 0) {
				/* Zeichenfarbe setzen */
				XSetForeground (display, myGC, hwarecolour.pixel );
			}
			else {
				printf ("Kann Farbzelle für %s nicht ermitteln\n", colourname);
				printf ("Verwende stattdessen Schwarz\n");
				XSetForeground(display, myGC,BlackPixel(display,screen));
			}
		}
		else {
			printf ("Kann Farbe %s nicht finden\n", colourname);
			printf ("Verwende stattdessen Schwarz\n");
			XSetForeground(display, myGC, BlackPixel(display, screen));
		}
	}
	else {
		printf("Keine Farbe in dieser Tiefe:%d ?!\n", myDepth);
		printf ("Verwende stattdessen Schwarz \n");
		XSetForeground (display, myGC, BlackPixel(display, screen));
	}
}

//**********************************************************************
void set_word(char o, char l) {
	char i;
	for (i=o; i<(o+l); i++) signs[i][1]=1;
}

//**********************************************************************
void draw_clock(Display *display, int screen, Window win, GC mygc, int width, int height)
{
	int i, j, h;

	// aktuelle Uhrzeit
	now = time (NULL);
	now_tm	= localtime (&now);
    now_s	= now_tm->tm_sec;
	now_m	= now_tm->tm_min;
	now_h	= now_tm->tm_hour;

	// Buchstabenmatrix "loeschen"
	for (i=0; i<110; i++) signs[i][1]=0;
	// Standardtext "it is ... o clock"
	set_word(it[0], it[1]);
	set_word(is[0], is[1]);
	set_word(o[0], o[1]);
	set_word(_clock[0], _clock[1]);
	//Minutentext generieren
	if (now_m < 5) {
				// ...leer
					}
	else if (now_m <10) {
				set_word(five[0], five[1]);
				set_word(past[0], past[1]);
						}
	else if (now_m <15) {
				set_word(ten[0], ten[1]);
				set_word(past[0], past[1]);
						}
	else if (now_m <20) {
				set_word(quarter[0], quarter[1]);
				set_word(past[0], past[1]);
						}
	else if (now_m <25) {
				set_word(twenty[0], twenty[1]);
				set_word(past[0], past[1]);
						}
	else if (now_m <30) {
				set_word(twenty[0], twenty[1]);
				set_word(five[0], five[1]);
				set_word(past[0], past[1]);
						}
	else if (now_m <35) {
				set_word(half[0], half[1]);
				set_word(past[0], past[1]);
						}
	else if (now_m <40) {
				set_word(twenty[0], twenty[1]);
				set_word(five[0], five[1]);
				set_word(to[0], to[1]);
						}
	else if (now_m <45) {
				set_word(twenty[0], twenty[1]);
				set_word(to[0], to[1]);
						}
	else if (now_m <50) {
				set_word(quarter[0], quarter[1]);
				set_word(to[0], to[1]);
						}
	else if (now_m <55) {
				set_word(ten[0], ten[1]);
				set_word(to[0], to[1]);
						}
	else if (now_m <=59) {
				set_word(five[0], five[1]);
				set_word(to[0], to[1]);
						}
	// Stundentext und AM/PM bestimmen
	if (now_h > 12) {
		h = now_h - 12; 
		ap[0] = 0;
		ap[1] = 1;
	} else {
		h = now_h;
		ap[0] = 1;
		ap[1] = 0;
	}
	if (now_m < 35) set_word(htxt[h-1][0],htxt[h-1][1]); else  set_word(htxt[h][0],htxt[h][1]);
	// Zwischenminuten ausgeben
	for (i=0; i<4; i++) if ((now_m%5)>i) min[i]=1; else min[i]=0;
	//Buchstabenmatrix neu ausgeben
	for (j=0; j<10; j++) {
		for (i=0; i<11; i++) {
			if (signs[j*11+i][1]) setcolourvianame (display, screen, mygc, "white");
			else setcolourvianame (display, screen, mygc, "grey20");
			XDrawString(display, win, mygc, 
				font_info->max_bounds.width+font_info->max_bounds.width*i*2, 
				(font_info->max_bounds.ascent+font_info->max_bounds.descent)+(font_info->max_bounds.ascent+font_info->max_bounds.descent)*j, 
				&signs[j*11+i][0], 1);
		}
	}
	// Zwischenminuten ausgeben
	for (i=0; i<4; i++) {
		if (min[i]) setcolourvianame (display, screen, mygc, "white");
		else setcolourvianame (display, screen, mygc, "grey20");
		XFillArc (display, win, mygc, 
							i*2*font_info->max_bounds.width+font_info->max_bounds.width+font_info->max_bounds.width/4, 
							10*(font_info->max_bounds.ascent+font_info->max_bounds.descent)+font_info->max_bounds.width, 
		        	        font_info->max_bounds.width/2, 
		        	        font_info->max_bounds.width/2, 
		        	        0, 360*64);
	}
	// AM/PM ausgeben
	for (i=0; i<2; i++) {
		if (ap[i]) setcolourvianame (display, screen, mygc, "white");
		else setcolourvianame (display, screen, mygc, "grey20");
		XFillArc (display, win, mygc, 
							(i+9)*2*font_info->max_bounds.width+font_info->max_bounds.width+font_info->max_bounds.width/4, 
							10*(font_info->max_bounds.ascent+font_info->max_bounds.descent)+font_info->max_bounds.width, 
		        	        font_info->max_bounds.width/2, 
		        	        font_info->max_bounds.width/2, 
		        	        0, 360*64);
	}
	//...
	XFlush (display);
}

//**********************************************************************
void sigh(int signal) {
	// im Sekundentakt wird ein Refresh-Ereignis an X gesendet...
	XClearArea(mydpy, mywin, 0, 0, 1, 1, True);
	XFlush(mydpy);
	alarm(1);
} 

//**********************************************************************
//**********************************************************************
//**********************************************************************
main(int argc, char *argv[])
{
	GC mygc;
	XEvent myevent;
	XSizeHints myhint;
	XWindowAttributes mywinattr;
	int myscreen;
	unsigned long fg, bg;
	unsigned int win_width, win_height;
	char text[10];


	// X-Fenster initialisieren
	if(!(mydpy = XOpenDisplay(NULL))) {
		(void)fprintf(stderr, "Unable to open display: %s\n",
		XDisplayString(NULL));
	exit(1);
	}
	myscreen = DefaultScreen(mydpy);
	fg = WhitePixel(mydpy, myscreen);
	bg = BlackPixel(mydpy, myscreen);
	// Font laden
	font_info = XLoadQueryFont(mydpy, font_name);
	if (!font_info) {
		fprintf(stderr, "XLoadQueryFont: failed loading font '%s'\n", font_name);
	}
	// Fenstergroesse nach Fontgroesse berechnen
	myhint.x = WINDOW_WIDTH;
	myhint.y = WINDOW_HEIGHT;
	myhint.width = font_info->max_bounds.width+font_info->max_bounds.width*11*2;
	myhint.height = (font_info->max_bounds.ascent+font_info->max_bounds.descent)*12-font_info->max_bounds.width;
	myhint.flags = PPosition | PSize;
	mywin = XCreateSimpleWindow(mydpy,
			DefaultRootWindow(mydpy),
			myhint.x, myhint.y, myhint.width, myhint.height,
			5, fg, bg);
	XSetStandardProperties(mydpy, mywin, win_title, win_title,
			None, argv, argc, &myhint);
	mygc = XCreateGC(mydpy, mywin, 0, 0);
	XSetForeground(mydpy, mygc, fg);
	XSetBackground(mydpy, mygc, bg);
	XSelectInput(mydpy, mywin,
			ButtonPressMask | KeyPressMask | ExposureMask);
	XMapRaised(mydpy, mywin);
 	// Font setzen
 	XSetFont(mydpy, mygc, font_info->fid);
 	XFlush(mydpy);
	// Uhr das 1.Mal zeichnen
	draw_clock(mydpy, myscreen, mywin, mygc, myhint.width, myhint.height);
	// Sekundentimer initialisieren (fast so, wie bei MCs :-))
	signal(SIGALRM, sigh);
	alarm(1); 
	// Endlosloop
	while(1) {
		XNextEvent(mydpy, &myevent);
		switch(myevent.type) {
			case Expose:
					if(myevent.xexpose.count == 0){
						XGetWindowAttributes(mydpy, mywin, &mywinattr);
						win_width = mywinattr.width;
						win_height= mywinattr.height;
						draw_clock(mydpy, myscreen, mywin, mygc, win_width, win_height);
					}
					break;

			case MappingNotify:
					break;

			case ButtonPress:
					break;

			case KeyPress:
					draw_clock(mydpy, myscreen, mywin, mygc, win_width, win_height);
					break;
		}
	}
	// Programm kommt zwar nie hier hin, aber der Ordnung halber...;-)
	XFreeGC(mydpy, mygc);
	XDestroyWindow(mydpy, mywin);
	XCloseDisplay(mydpy);
	exit(0);
}

